% eliminer symetries et ajouter contrainte redondantes
declare
fun {MagicSquare N}
   NN  = N*N
   L1N = {List.number 1 N 1}  % [1 2 3 ... N]
in 
   proc {$ Square}
      Sum = {FD.decl}
      fun {Field I J} % domaine en ligne I colonne J
	 Square.((I-1)*N + J)
      end 
      proc {Assert F}
             % {F 1} + {F 2} + ... + {F N} =: Sum
		 {FD.sum {Map L1N F} '=:' Sum}
      end 
   in 
      {FD.tuple square NN 1#NN Square}
      {FD.distinct Square}
      %% Diagonals
      {Assert fun {$ I} {Field I I} end}
      {Assert fun {$ I} {Field I N+1-I} end}
      %% Rows
      for R in 1..N do
		 {Assert fun {$ J} {Field R J} end}
      end
      %% Columns
      for C in 1..N do
		 {Assert fun {$ I} {Field I C} end}
      end
      %% Eliminate symmetries
      {Field 1 1} <: {Field N N}
      {Field N 1} <: {Field 1 N}
      {Field 1 1} <: {Field N 1}
      %% Redundant: sum of all fields = (number rows) * Sum
      NN*(NN+1) div 2 =: N*Sum
      %% 
      {FD.distribute split Square}
   end 
end

declare
proc {MyExec P}
   Start End
in
   Start={OS.time}
   {Browse {SearchAll P}}
   End={OS.time}
   {Show (End-Start)}
end

{MyExec {MagicSquare 4}}

%{ExploreOne {MagicSquare 4}}
